package cn.wise.sc.consume.business.security;

import cn.wise.sc.consume.business.entity.SysUser;
import cn.wise.sc.consume.business.security.jwt.JwtUserService;
import cn.wise.sc.consume.business.service.SmsAuthService;
import cn.wise.sc.consume.business.service.impl.SmsAuthServiceImpl;
import cn.wise.sc.consume.business.wrapper.WrapMapper;
import cn.wise.sc.consume.business.wrapper.Wrapper;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.web.authentication.AuthenticationSuccessHandler;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.concurrent.TimeUnit;

public class JsonLoginSuccessHandler implements AuthenticationSuccessHandler {
    
    private JwtUserService jwtUserService;
    
    public JsonLoginSuccessHandler(JwtUserService jwtUserService) {
        this.jwtUserService = jwtUserService;
    }
    private ObjectMapper objectMapper = new ObjectMapper();

	private static final String ADMIN_LOGIN_TOKEN = "shiro:token:tmp:admin";

	@Autowired
	private SmsAuthService smsAuthService;
	@Autowired
	private StringRedisTemplate stringRedisTemplate;



    @Override
    public void onAuthenticationSuccess(HttpServletRequest request, HttpServletResponse response,
                                        Authentication authentication) throws IOException, ServletException {
                //生成token，并把token加密相关信息缓存，具体请看实现类
        String token = jwtUserService.saveUserLoginInfo((UserDetails)authentication.getPrincipal());
        response.setHeader("Authorization", token);
        response.setContentType("text/html;charset=utf-8");

        SysUser sysUser = (SysUser) authentication.getPrincipal();
        sysUser.setPassword(null);
        Wrapper wrapper = WrapMapper.wrap(200,"登陆成功",sysUser);
        /*if(sysUser.getIsAdmin() != 0){
	        response.setHeader("Authorization", "");
	        stringRedisTemplate.opsForValue().set(ADMIN_LOGIN_TOKEN + sysUser.getPhone(), token, 10, TimeUnit.MINUTES);
	        if (StringUtils.isNoneBlank(sysUser.getPhone()) && smsAuthService.getSendDate(sysUser.getPhone(), SmsAuthServiceImpl.LOGIN)) {
		        smsAuthService.sendMesModel(sysUser.getPhone(), SmsAuthServiceImpl.LOGIN);
		   *//* if (ret) {
			    wrapper = WrapMapper.wrap(200,"发送验证码成功");
		    }*//*
	        }else{
		        wrapper = WrapMapper.wrap(400,"发送验证码失败");
	        }
        }*/
        response.getWriter().write(objectMapper.writeValueAsString(wrapper));
    }
    
}